(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/platform'), require('@angular/cdk/scrolling'), require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/animations')) :
    typeof define === 'function' && define.amd ? define('ngx-bootstrap-navbar', ['exports', '@angular/cdk/platform', '@angular/cdk/scrolling', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/animations'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-bootstrap-navbar'] = {}, global.ng.cdk.platform, global.ng.cdk.scrolling, global.ng.common, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.animations));
}(this, (function (exports, platform, scrolling, common, core, rxjs, operators, animations) { 'use strict';

    var NgxNavbarDynamicExpandDirective = /** @class */ (function () {
        function NgxNavbarDynamicExpandDirective(viewportRuler, elRef, ngZone, cdRef, platform, document) {
            var _this = this;
            this.viewportRuler = viewportRuler;
            this.elRef = elRef;
            this.ngZone = ngZone;
            this.cdRef = cdRef;
            this.platform = platform;
            this.onDestroy$ = new rxjs.Subject();
            this.update$ = new rxjs.Subject();
            this.loaded = false;
            this._isExpanded = false;
            this._document = document;
            this.ngZone.runOutsideAngular(function () {
                rxjs.merge(_this.viewportRuler.change(150), _this.update$)
                    .pipe(operators.filter(function () { return _this.loaded ||
                    (_this.loaded = checkBootstrapStylesAreLoaded(_this._document, _this.elRef.nativeElement)); }), operators.map(function () {
                    var element = _this.elRef.nativeElement;
                    var overflowSize;
                    if (_this.isExpanded) {
                        overflowSize = element.scrollWidth - element.offsetWidth;
                    }
                    else {
                        var clone = element.cloneNode(true);
                        clone.classList.add('navbar-expand');
                        var parent = element.parentElement;
                        if (parent) {
                            parent.appendChild(clone);
                            overflowSize = clone.scrollWidth - clone.offsetWidth;
                            parent.removeChild(clone);
                        }
                    }
                    return !overflowSize;
                }), operators.distinctUntilChanged(), operators.takeUntil(_this.onDestroy$))
                    .subscribe(function (isExpanded) {
                    _this.ngZone.run(function () {
                        _this._isExpanded = isExpanded;
                        _this.cdRef.markForCheck();
                    });
                });
            });
        }
        Object.defineProperty(NgxNavbarDynamicExpandDirective.prototype, "isExpanded", {
            get: function () {
                return this._isExpanded;
            },
            enumerable: false,
            configurable: true
        });
        NgxNavbarDynamicExpandDirective.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (!this.platform.isBrowser) {
                return;
            }
            this.ngZone.runOutsideAngular(function () {
                _this.loaded = checkBootstrapStylesAreLoaded(_this._document, _this.elRef.nativeElement);
                if (_this.loaded) {
                    _this.updateExpansion();
                }
                else {
                    setTimeout(function () {
                        _this.ngAfterContentInit();
                    }, 1000 / 60);
                }
            });
        };
        NgxNavbarDynamicExpandDirective.prototype.ngOnDestroy = function () {
            this.update$.complete();
            this.onDestroy$.next();
            this.onDestroy$.complete();
        };
        NgxNavbarDynamicExpandDirective.prototype.updateExpansion = function () {
            this.update$.next();
        };
        return NgxNavbarDynamicExpandDirective;
    }());
    NgxNavbarDynamicExpandDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[ngxNavbarDynamicExpand]',
                    host: {
                        class: 'navbar text-nowrap',
                        '[class.navbar-expand]': 'isExpanded',
                    },
                },] }
    ];
    NgxNavbarDynamicExpandDirective.ctorParameters = function () { return [
        { type: scrolling.ViewportRuler },
        { type: core.ElementRef },
        { type: core.NgZone },
        { type: core.ChangeDetectorRef },
        { type: platform.Platform },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
    ]; };
    function checkBootstrapStylesAreLoaded(document, element) {
        var documentWindow = document.defaultView || window;
        var computedStyle = documentWindow && documentWindow.getComputedStyle
            ? documentWindow.getComputedStyle(element)
            : false;
        return computedStyle && computedStyle.whiteSpace === 'nowrap';
    }

    /** Time and timing curve for navbar animations. */
    var NAVBAR_ANIMATION_TIMING = '300ms ease-out';
    var ngxNavbarAnimations = {
        navbarSlide: animations.trigger('slideState', [
            animations.transition('false => true', [
                animations.style({
                    opacity: 0,
                    height: 0,
                    overflow: 'hidden'
                }),
                animations.animate(NAVBAR_ANIMATION_TIMING, animations.style({
                    opacity: 1,
                    height: '*'
                }))
            ]),
            animations.transition('true => false', [
                animations.animate(NAVBAR_ANIMATION_TIMING, animations.style({
                    display: 'block',
                    opacity: 0,
                    height: 0,
                    overflow: 'hidden'
                }))
            ])
        ])
    };

    var NgxNavbarCollapseComponent = /** @class */ (function () {
        function NgxNavbarCollapseComponent(cdRef) {
            this.cdRef = cdRef;
            this.isCollapsed = true;
            this.isTransitioning = false;
        }
        NgxNavbarCollapseComponent.prototype.toggle = function () {
            this.isTransitioning = true;
            this.isCollapsed = !this.isCollapsed;
            this.cdRef.markForCheck();
        };
        NgxNavbarCollapseComponent.prototype.close = function () {
            if (this.isCollapsed) {
                return;
            }
            this.isTransitioning = true;
            this.isCollapsed = true;
            this.cdRef.markForCheck();
        };
        NgxNavbarCollapseComponent.prototype.open = function () {
            if (!this.isCollapsed) {
                return;
            }
            this.isTransitioning = true;
            this.isCollapsed = false;
            this.cdRef.markForCheck();
        };
        return NgxNavbarCollapseComponent;
    }());
    NgxNavbarCollapseComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ngx-navbar-collapse',
                    template: "\n    <ng-content></ng-content>\n  ",
                    host: {
                        class: 'navbar-collapse ngx-navbar-collapse',
                        '[class.collapse]': '!isTransitioning',
                        '[class.show]': '!isCollapsed && !isTransitioning',
                        '[class.collapsing]': 'isTransitioning',
                        '[@slideState]': '!isCollapsed',
                        '(@slideState.done)': 'isTransitioning = false'
                    },
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    animations: [ngxNavbarAnimations.navbarSlide],
                    exportAs: 'ngxNavbarCollapse',
                    styles: ["\n      .ngx-navbar-collapse.collapsing {\n        height: auto;\n      }\n    "]
                },] }
    ];
    NgxNavbarCollapseComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };

    var NgxNavbarModule = /** @class */ (function () {
        function NgxNavbarModule() {
        }
        return NgxNavbarModule;
    }());
    NgxNavbarModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [NgxNavbarCollapseComponent, NgxNavbarDynamicExpandDirective],
                    imports: [common.CommonModule],
                    exports: [NgxNavbarCollapseComponent, NgxNavbarDynamicExpandDirective]
                },] }
    ];

    /*
     * Public API Surface of ngx-bootstrap-navbar
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NAVBAR_ANIMATION_TIMING = NAVBAR_ANIMATION_TIMING;
    exports.NgxNavbarCollapseComponent = NgxNavbarCollapseComponent;
    exports.NgxNavbarDynamicExpandDirective = NgxNavbarDynamicExpandDirective;
    exports.NgxNavbarModule = NgxNavbarModule;
    exports.ngxNavbarAnimations = ngxNavbarAnimations;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-bootstrap-navbar.umd.js.map
